Index: palm/trunk/SOURCE/poismg.f90
===================================================================
--- palm/trunk/SOURCE/poismg.f90	(revision 1761)
+++ palm/trunk/SOURCE/poismg.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Introduction of nested domain feature
 ! 
 ! Former revisions:
@@ -259,5 +259,6 @@
     USE control_parameters,                                                    &
         ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,   &
-               inflow_n, inflow_r, inflow_s, outflow_l, outflow_n, outflow_r,  &
+               inflow_n, inflow_r, inflow_s, nest_bound_l, nest_bound_n,       &
+               nest_bound_r, nest_bound_s, outflow_l, outflow_n, outflow_r,    &
                outflow_s
 
@@ -353,11 +354,19 @@
 
     IF ( .NOT. bc_lr_cyc )  THEN
-       IF ( inflow_l .OR. outflow_l )  r(:,:,nxl_mg(l)-1) = r(:,:,nxl_mg(l))
-       IF ( inflow_r .OR. outflow_r )  r(:,:,nxr_mg(l)+1) = r(:,:,nxr_mg(l))
+       IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
+          r(:,:,nxl_mg(l)-1) = r(:,:,nxl_mg(l))
+       ENDIF
+       IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
+          r(:,:,nxr_mg(l)+1) = r(:,:,nxr_mg(l))
+       ENDIF
     ENDIF
 
     IF ( .NOT. bc_ns_cyc )  THEN
-       IF ( inflow_n .OR. outflow_n )  r(:,nyn_mg(l)+1,:) = r(:,nyn_mg(l),:)
-       IF ( inflow_s .OR. outflow_s )  r(:,nys_mg(l)-1,:) = r(:,nys_mg(l),:)
+       IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
+          r(:,nyn_mg(l)+1,:) = r(:,nyn_mg(l),:)
+       ENDIF
+       IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
+          r(:,nys_mg(l)-1,:) = r(:,nys_mg(l),:)
+       ENDIF
     ENDIF
 
@@ -393,5 +402,6 @@
     USE control_parameters,                                                    &
         ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,   &
-               inflow_n, inflow_r, inflow_s, outflow_l, outflow_n, outflow_r,  &
+               inflow_n, inflow_r, inflow_s, nest_bound_l, nest_bound_n,       &
+               nest_bound_r, nest_bound_s, outflow_l, outflow_n, outflow_r,    &
                outflow_s
 
@@ -560,11 +570,19 @@
 
     IF ( .NOT. bc_lr_cyc )  THEN
-       IF (inflow_l .OR. outflow_l)  f_mg(:,:,nxl_mg(l)-1) = f_mg(:,:,nxl_mg(l))
-       IF (inflow_r .OR. outflow_r)  f_mg(:,:,nxr_mg(l)+1) = f_mg(:,:,nxr_mg(l))
+       IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
+          f_mg(:,:,nxl_mg(l)-1) = f_mg(:,:,nxl_mg(l))
+       ENDIF
+       IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
+          f_mg(:,:,nxr_mg(l)+1) = f_mg(:,:,nxr_mg(l))
+       ENDIF
     ENDIF
 
     IF ( .NOT. bc_ns_cyc )  THEN
-       IF (inflow_n .OR. outflow_n)  f_mg(:,nyn_mg(l)+1,:) = f_mg(:,nyn_mg(l),:)
-       IF (inflow_s .OR. outflow_s)  f_mg(:,nys_mg(l)-1,:) = f_mg(:,nys_mg(l),:)
+       IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
+          f_mg(:,nyn_mg(l)+1,:) = f_mg(:,nyn_mg(l),:)
+       ENDIF
+       IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
+          f_mg(:,nys_mg(l)-1,:) = f_mg(:,nys_mg(l),:)
+       ENDIF
     ENDIF
 
@@ -600,5 +618,6 @@
     USE control_parameters,                                                    &
         ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,   &
-               inflow_n, inflow_r, inflow_s, outflow_l, outflow_n, outflow_r,  &
+               inflow_n, inflow_r, inflow_s, nest_bound_l, nest_bound_n,       &
+               nest_bound_r, nest_bound_s, outflow_l, outflow_n, outflow_r,    &
                outflow_s
 
@@ -668,11 +687,19 @@
 
     IF ( .NOT. bc_lr_cyc )  THEN
-       IF (inflow_l .OR. outflow_l)  temp(:,:,nxl_mg(l)-1) = temp(:,:,nxl_mg(l))
-       IF (inflow_r .OR. outflow_r)  temp(:,:,nxr_mg(l)+1) = temp(:,:,nxr_mg(l))
+       IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
+          temp(:,:,nxl_mg(l)-1) = temp(:,:,nxl_mg(l))
+       ENDIF
+       IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
+          temp(:,:,nxr_mg(l)+1) = temp(:,:,nxr_mg(l))
+       ENDIF
     ENDIF
 
     IF ( .NOT. bc_ns_cyc )  THEN
-       IF (inflow_n .OR. outflow_n)  temp(:,nyn_mg(l)+1,:) = temp(:,nyn_mg(l),:)
-       IF (inflow_s .OR. outflow_s)  temp(:,nys_mg(l)-1,:) = temp(:,nys_mg(l),:)
+       IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
+          temp(:,nyn_mg(l)+1,:) = temp(:,nyn_mg(l),:)
+       ENDIF
+       IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
+          temp(:,nys_mg(l)-1,:) = temp(:,nys_mg(l),:)
+       ENDIF
     ENDIF
 
@@ -709,5 +736,6 @@
     USE control_parameters,                                                    &
         ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,   &
-               inflow_n, inflow_r, inflow_s, ngsrb, outflow_l, outflow_n,      &
+               inflow_n, inflow_r, inflow_s, ngsrb, nest_bound_l,              &
+               nest_bound_n, nest_bound_r, nest_bound_s, outflow_l, outflow_n, &
                outflow_r, outflow_s
 
@@ -1068,8 +1096,8 @@
 
           IF ( .NOT. bc_lr_cyc )  THEN
-             IF ( inflow_l .OR. outflow_l )  THEN
+             IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
                 p_mg(:,:,nxl_mg(l)-1) = p_mg(:,:,nxl_mg(l))
              ENDIF
-             IF ( inflow_r .OR. outflow_r )  THEN
+             IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
                 p_mg(:,:,nxr_mg(l)+1) = p_mg(:,:,nxr_mg(l))
              ENDIF
@@ -1077,8 +1105,8 @@
 
           IF ( .NOT. bc_ns_cyc )  THEN
-             IF ( inflow_n .OR. outflow_n )  THEN
+             IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
                 p_mg(:,nyn_mg(l)+1,:) = p_mg(:,nyn_mg(l),:)
              ENDIF
-             IF ( inflow_s .OR. outflow_s )  THEN
+             IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
                 p_mg(:,nys_mg(l)-1,:) = p_mg(:,nys_mg(l),:)
              ENDIF
@@ -1296,6 +1324,7 @@
                gamma_mg, grid_level, grid_level_count, ibc_p_b, ibc_p_t,       &
                inflow_l, inflow_n, inflow_r, inflow_s, maximum_grid_level,     &
-               mg_switch_to_pe0_level, mg_switch_to_pe0, ngsrb, outflow_l,     &
-               outflow_n, outflow_r, outflow_s
+               mg_switch_to_pe0_level, mg_switch_to_pe0, nest_domain,          &
+               nest_bound_l, nest_bound_n, nest_bound_r, nest_bound_s, ngsrb,  &
+               outflow_l, outflow_n, outflow_r, outflow_s
 
 
@@ -1446,4 +1475,7 @@
              outflow_l = .TRUE.
              outflow_r = .FALSE.
+          ELSEIF ( nest_domain )  THEN
+             nest_bound_l = .TRUE.
+             nest_bound_r = .TRUE.
           ENDIF
 
@@ -1458,4 +1490,7 @@
              outflow_n = .TRUE.
              outflow_s = .FALSE.
+          ELSEIF ( nest_domain )  THEN
+             nest_bound_s = .TRUE.
+             nest_bound_n = .TRUE.
           ENDIF
 
@@ -1528,4 +1563,6 @@
              ELSEIF ( bc_lr_raddir )  THEN
                 outflow_l = .TRUE.
+             ELSEIF ( nest_domain )  THEN
+                nest_bound_l = .TRUE.
              ENDIF
           ENDIF
@@ -1536,4 +1573,6 @@
              ELSEIF ( bc_lr_raddir )  THEN
                 inflow_r  = .TRUE.
+             ELSEIF ( nest_domain )  THEN
+                nest_bound_r = .TRUE.
              ENDIF
           ENDIF
@@ -1544,4 +1583,6 @@
              ELSEIF ( bc_ns_raddir )  THEN
                 inflow_s  = .TRUE.
+             ELSEIF ( nest_domain )  THEN
+                nest_bound_s = .TRUE.
              ENDIF
           ENDIF
@@ -1552,4 +1593,6 @@
              ELSEIF ( bc_ns_raddir )  THEN
                 outflow_n = .TRUE.
+             ELSEIF ( nest_domain )  THEN
+                nest_bound_n = .TRUE.
              ENDIF
           ENDIF
Index: palm/trunk/SOURCE/poismg_fast.f90
===================================================================
--- palm/trunk/SOURCE/poismg_fast.f90	(revision 1761)
+++ palm/trunk/SOURCE/poismg_fast.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Introduction of nested domain feature
 ! 
 ! Former revisions:
@@ -240,5 +240,6 @@
        USE control_parameters,                                                 &
            ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,&
-                  inflow_n, inflow_r, inflow_s, masking_method, outflow_l,     &
+                  inflow_n, inflow_r, inflow_s, masking_method, nest_bound_l,  &
+                  nest_bound_n, nest_bound_r, nest_bound_s, outflow_l,         &
                   outflow_n, outflow_r, outflow_s, topography
 
@@ -393,11 +394,19 @@
 
        IF ( .NOT. bc_lr_cyc )  THEN
-          IF ( inflow_l .OR. outflow_l )  r(:,:,nxl_mg(l)-1) = r(:,:,nxl_mg(l))
-          IF ( inflow_r .OR. outflow_r )  r(:,:,nxr_mg(l)+1) = r(:,:,nxr_mg(l))
+          IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
+             r(:,:,nxl_mg(l)-1) = r(:,:,nxl_mg(l))
+          ENDIF
+          IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
+             r(:,:,nxr_mg(l)+1) = r(:,:,nxr_mg(l))
+          ENDIF
        ENDIF
 
        IF ( .NOT. bc_ns_cyc )  THEN
-          IF ( inflow_n .OR. outflow_n )  r(:,nyn_mg(l)+1,:) = r(:,nyn_mg(l),:)
-          IF ( inflow_s .OR. outflow_s )  r(:,nys_mg(l)-1,:) = r(:,nys_mg(l),:)
+          IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
+             r(:,nyn_mg(l)+1,:) = r(:,nyn_mg(l),:)
+          ENDIF
+          IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
+             r(:,nys_mg(l)-1,:) = r(:,nys_mg(l),:)
+          ENDIF
        ENDIF
 
@@ -434,5 +443,6 @@
        USE control_parameters,                                                 &
            ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,&
-                  inflow_n, inflow_r, inflow_s, masking_method, outflow_l,     &
+                  inflow_n, inflow_r, inflow_s, masking_method, nest_bound_l,  &
+                  nest_bound_n, nest_bound_r, nest_bound_s, outflow_l,         &
                   outflow_n, outflow_r, outflow_s, topography
 
@@ -635,11 +645,19 @@
 
        IF ( .NOT. bc_lr_cyc )  THEN
-          IF (inflow_l .OR. outflow_l)  f_mg(:,:,nxl_mg(l)-1) = f_mg(:,:,nxl_mg(l))
-          IF (inflow_r .OR. outflow_r)  f_mg(:,:,nxr_mg(l)+1) = f_mg(:,:,nxr_mg(l))
+          IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
+             f_mg(:,:,nxl_mg(l)-1) = f_mg(:,:,nxl_mg(l))
+          ENDIF
+          IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
+             f_mg(:,:,nxr_mg(l)+1) = f_mg(:,:,nxr_mg(l))
+          ENDIF
        ENDIF
 
        IF ( .NOT. bc_ns_cyc )  THEN
-          IF (inflow_n .OR. outflow_n)  f_mg(:,nyn_mg(l)+1,:) = f_mg(:,nyn_mg(l),:)
-          IF (inflow_s .OR. outflow_s)  f_mg(:,nys_mg(l)-1,:) = f_mg(:,nys_mg(l),:)
+          IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
+             f_mg(:,nyn_mg(l)+1,:) = f_mg(:,nyn_mg(l),:)
+          ENDIF
+          IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
+             f_mg(:,nys_mg(l)-1,:) = f_mg(:,nys_mg(l),:)
+          ENDIF
        ENDIF
 
@@ -679,5 +697,6 @@
        USE control_parameters,                                                 &
            ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,&
-                  inflow_n, inflow_r, inflow_s, outflow_l, outflow_n,          &
+                  inflow_n, inflow_r, inflow_s, nest_bound_l, nest_bound_n,    &
+                  nest_bound_r, nest_bound_s, outflow_l, outflow_n,            &
                   outflow_r, outflow_s
 
@@ -790,11 +809,19 @@
 
        IF ( .NOT. bc_lr_cyc )  THEN
-          IF (inflow_l .OR. outflow_l)  temp(:,:,nxl_mg(l)-1) = temp(:,:,nxl_mg(l))
-          IF (inflow_r .OR. outflow_r)  temp(:,:,nxr_mg(l)+1) = temp(:,:,nxr_mg(l))
+          IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
+             temp(:,:,nxl_mg(l)-1) = temp(:,:,nxl_mg(l))
+          ENDIF
+          IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
+             temp(:,:,nxr_mg(l)+1) = temp(:,:,nxr_mg(l))
+          ENDIF
        ENDIF
 
        IF ( .NOT. bc_ns_cyc )  THEN
-          IF (inflow_n .OR. outflow_n)  temp(:,nyn_mg(l)+1,:) = temp(:,nyn_mg(l),:)
-          IF (inflow_s .OR. outflow_s)  temp(:,nys_mg(l)-1,:) = temp(:,nys_mg(l),:)
+          IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
+             temp(:,nyn_mg(l)+1,:) = temp(:,nyn_mg(l),:)
+          ENDIF
+          IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
+             temp(:,nys_mg(l)-1,:) = temp(:,nys_mg(l),:)
+          ENDIF
        ENDIF
 
@@ -832,5 +859,6 @@
        USE control_parameters,                                                 &
            ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,&
-                  inflow_n, inflow_r, inflow_s, masking_method, ngsrb,         &
+                  inflow_n, inflow_r, inflow_s, masking_method, nest_bound_l,  &
+                  nest_bound_n, nest_bound_r, nest_bound_s, ngsrb,             &
                   outflow_l, outflow_n, outflow_r, outflow_s, topography
 
@@ -1411,9 +1439,9 @@
              CALL special_exchange_horiz( p_mg, color )
 
-              IF ( .NOT. bc_lr_cyc )  THEN
-                IF ( inflow_l .OR. outflow_l )  THEN
+             IF ( .NOT. bc_lr_cyc )  THEN
+                IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
                    p_mg(:,:,nxl_mg(l)-1) = p_mg(:,:,nxl_mg(l))
                 ENDIF
-                IF ( inflow_r .OR. outflow_r )  THEN
+                IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
                    p_mg(:,:,nxr_mg(l)+1) = p_mg(:,:,nxr_mg(l))
                 ENDIF
@@ -1421,8 +1449,8 @@
 
              IF ( .NOT. bc_ns_cyc )  THEN
-                IF ( inflow_n .OR. outflow_n )  THEN
+                IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
                    p_mg(:,nyn_mg(l)+1,:) = p_mg(:,nyn_mg(l),:)
                 ENDIF
-                IF ( inflow_s .OR. outflow_s )  THEN
+                IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
                    p_mg(:,nys_mg(l)-1,:) = p_mg(:,nys_mg(l),:)
                 ENDIF
@@ -1913,6 +1941,7 @@
                   gamma_mg, grid_level, grid_level_count, ibc_p_b, ibc_p_t,    &
                   inflow_l, inflow_n, inflow_r, inflow_s, maximum_grid_level,  &
-                  mg_switch_to_pe0_level, mg_switch_to_pe0, ngsrb, outflow_l,  &
-                  outflow_n, outflow_r, outflow_s
+                  mg_switch_to_pe0_level, mg_switch_to_pe0, nest_domain,       &
+                  nest_bound_l, nest_bound_n, nest_bound_r, nest_bound_s,      &
+                  ngsrb, outflow_l, outflow_n, outflow_r, outflow_s
 
        USE indices,                                                            &
@@ -2062,4 +2091,7 @@
                 outflow_l = .TRUE.
                 outflow_r = .FALSE.
+             ELSEIF ( nest_domain )  THEN
+                nest_bound_l = .TRUE.
+                nest_bound_r = .TRUE.
              ENDIF
 
@@ -2074,4 +2106,7 @@
                 outflow_n = .TRUE.
                 outflow_s = .FALSE.
+             ELSEIF ( nest_domain )  THEN
+                nest_bound_s = .TRUE.
+                nest_bound_n = .TRUE.
              ENDIF
 
@@ -2146,4 +2181,6 @@
                 ELSEIF ( bc_lr_raddir )  THEN
                    outflow_l = .TRUE.
+                ELSEIF ( nest_domain )  THEN
+                   nest_bound_l = .TRUE.
                 ENDIF
              ENDIF
@@ -2154,4 +2191,6 @@
                 ELSEIF ( bc_lr_raddir )  THEN
                    inflow_r  = .TRUE.
+                ELSEIF ( nest_domain )  THEN
+                   nest_bound_r = .TRUE.
                 ENDIF
              ENDIF
@@ -2162,4 +2201,6 @@
                 ELSEIF ( bc_ns_raddir )  THEN
                    inflow_s  = .TRUE.
+                ELSEIF ( nest_domain )  THEN
+                   nest_bound_s = .TRUE.
                 ENDIF
              ENDIF
@@ -2170,4 +2211,6 @@
                 ELSEIF ( bc_ns_raddir )  THEN
                    outflow_n = .TRUE.
+                ELSEIF ( nest_domain )  THEN
+                   nest_bound_n = .TRUE.
                 ENDIF
              ENDIF
Index: palm/trunk/SOURCE/pres.f90
===================================================================
--- palm/trunk/SOURCE/pres.f90	(revision 1761)
+++ palm/trunk/SOURCE/pres.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Introduction of nested domain feature
 ! 
 ! Former revisions:
@@ -98,7 +98,9 @@
         ONLY:  bc_lr_cyc, bc_ns_cyc, conserve_volume_flow, dt_3d,              &
                gathered_size, ibc_p_b, ibc_p_t, intermediate_timestep_count,   &
-               mg_switch_to_pe0_level, on_device, outflow_l, outflow_n,        &
-               outflow_r, outflow_s, psolver, simulated_time, subdomain_size,  &
-               topography, volume_flow, volume_flow_area, volume_flow_initial
+               mg_switch_to_pe0_level, nest_domain, nest_bound_l,              &
+               nest_bound_n, nest_bound_r, nest_bound_s, on_device, outflow_l, &
+               outflow_n, outflow_r, outflow_s, psolver, simulated_time,       &
+               subdomain_size, topography, volume_flow, volume_flow_area,      &
+               volume_flow_initial
 
     USE cpulog,                                                                &
@@ -138,6 +140,6 @@
     REAL(wp)     ::  d_weight_pres  !<
 
-    REAL(wp), DIMENSION(1:2)   ::  volume_flow_l       !<
-    REAL(wp), DIMENSION(1:2)   ::  volume_flow_offset  !<
+    REAL(wp), DIMENSION(1:3)   ::  volume_flow_l       !<
+    REAL(wp), DIMENSION(1:3)   ::  volume_flow_offset  !<
     REAL(wp), DIMENSION(1:nzt) ::  w_l                 !<
     REAL(wp), DIMENSION(1:nzt) ::  w_l_l               !<
@@ -162,5 +164,5 @@
 !--    cannot be used in the iterative solver. Therefore, its initial value is
 !--    stored on p_loc, which is then iteratively advanced in every substep.
-       IF ( intermediate_timestep_count == 1 )  THEN
+       IF ( intermediate_timestep_count <= 1 )  THEN
           DO  i = nxl-1, nxr+1
              DO  j = nys-1, nyn+1
@@ -267,6 +269,7 @@
 
 !
-!-- Remove mean vertical velocity
-    IF ( ibc_p_b == 1  .AND.  ibc_p_t == 1 )  THEN
+!-- Remove mean vertical velocity in case that Neumann conditions are
+!-- used both at bottom and top boundary, and if not a nested domain
+    IF ( ibc_p_b == 1  .AND.  ibc_p_t == 1  .AND.  .NOT. nest_domain)  THEN
        IF ( simulated_time > 0.0_wp )  THEN ! otherwise nzb_w_inner not yet known
           w_l = 0.0_wp;  w_l_l = 0.0_wp
@@ -561,5 +564,5 @@
        !$OMP END PARALLEL
 
-    ELSE 
+    ELSEIF ( intermediate_timestep_count > 1 )  THEN
        !$OMP PARALLEL PRIVATE (i,j,k)
        !$OMP DO
Index: palm/trunk/SOURCE/sor.f90
===================================================================
--- palm/trunk/SOURCE/sor.f90	(revision 1761)
+++ palm/trunk/SOURCE/sor.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Introduction of nested domain feature
 ! 
 ! Former revisions:
@@ -64,5 +64,6 @@
     USE control_parameters,                                                    &
         ONLY:  bc_lr_cyc, bc_ns_cyc, ibc_p_b, ibc_p_t, inflow_l, inflow_n,     &
-               inflow_r, inflow_s, n_sor, omega_sor, outflow_l, outflow_n,     &
+               inflow_r, inflow_s, nest_bound_l, nest_bound_n, nest_bound_r,   &
+               nest_bound_s, n_sor, omega_sor, outflow_l, outflow_n,           &
                outflow_r, outflow_s
 
@@ -154,10 +155,10 @@
 !--    Horizontal (Neumann) boundary conditions in case of non-cyclic boundaries
        IF ( .NOT. bc_lr_cyc )  THEN
-          IF ( inflow_l .OR. outflow_l )  p(:,:,nxl-1) = p(:,:,nxl)
-          IF ( inflow_r .OR. outflow_r )  p(:,:,nxr+1) = p(:,:,nxr)
+          IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  p(:,:,nxl-1) = p(:,:,nxl)
+          IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  p(:,:,nxr+1) = p(:,:,nxr)
        ENDIF
        IF ( .NOT. bc_ns_cyc )  THEN
-          IF ( inflow_n .OR. outflow_n )  p(:,nyn+1,:) = p(:,nyn,:)
-          IF ( inflow_s .OR. outflow_s )  p(:,nys-1,:) = p(:,nys,:)
+          IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  p(:,nyn+1,:) = p(:,nyn,:)
+          IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  p(:,nys-1,:) = p(:,nys,:)
        ENDIF
 
@@ -216,10 +217,10 @@
 !--    Horizontal (Neumann) boundary conditions in case of non-cyclic boundaries
        IF ( .NOT. bc_lr_cyc )  THEN
-          IF ( inflow_l .OR. outflow_l )  p(:,:,nxl-1) = p(:,:,nxl)
-          IF ( inflow_r .OR. outflow_r )  p(:,:,nxr+1) = p(:,:,nxr)
+          IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  p(:,:,nxl-1) = p(:,:,nxl)
+          IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  p(:,:,nxr+1) = p(:,:,nxr)
        ENDIF
        IF ( .NOT. bc_ns_cyc )  THEN
-          IF ( inflow_n .OR. outflow_n )  p(:,nyn+1,:) = p(:,nyn,:)
-          IF ( inflow_s .OR. outflow_s )  p(:,nys-1,:) = p(:,nys,:)
+          IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  p(:,nyn+1,:) = p(:,nyn,:)
+          IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  p(:,nys-1,:) = p(:,nys,:)
        ENDIF
 
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1761)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Introduction of nested domain feature
 !
 ! Former revisions:
@@ -165,7 +165,7 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  diss, dzu, e_p, nr_p, prho, pt, pt_p, pt_init, q_init, q, ql,   &
-               ql_c, ql_v, ql_vp, qr_p, q_p, ref_state, rho, sa_p, tend, u,    &
-               u_p, v, vpt, v_p, w_p
+        ONLY:  diss, dzu, e, e_p, nr_p, prho, pt, pt_p, pt_init, q_init, q,    &
+               ql, ql_c, ql_v, ql_vp, qr_p, q_p, ref_state, rho, sa_p, tend,   &
+               u, u_p, v, vpt, v_p, w, w_p
 
     USE calc_mean_profile_mod,                                                 &
@@ -188,5 +188,5 @@
                icloud_scheme, intermediate_timestep_count,                     &
                intermediate_timestep_count_max, large_scale_forcing,           &
-               loop_optimization, lsf_surf, lsf_vert, masks, mid,              &
+               loop_optimization, lsf_surf, lsf_vert, masks, mid, nest_domain, &
                netcdf_data_format, neutral, nr_timesteps_this_run, nudging,    &
                ocean, on_device, passive_scalar, precipitation,                &
@@ -235,4 +235,13 @@
     USE pegrid
 
+#if defined( PMC_ACTIVE )
+    USE pmc_interface,                                                         &
+        ONLY:  client_to_server, nesting_mode,                                 &
+               pmci_ensure_nest_mass_conservation, pmci_client_datatrans,      &
+               pmci_client_initialize, pmci_client_synchronize,                &
+               pmci_server_datatrans, pmci_server_initialize,                  &
+               pmci_server_synchronize, pmci_update_new, server_to_client
+#endif
+
     USE production_e_mod,                                                      &
         ONLY:  production_e_init
@@ -290,4 +299,48 @@
     ENDIF
 
+#if defined( PMC_ACTIVE )
+!
+!-- TO_DO: try to give more meaningful comments here
+!-- Domain nesting: From server to client commmunication
+!-- ( direction=SERVER_TO_CLIENT )
+!-- Nest initial conditions
+!
+!-- Send initial condition data from server to client
+    CALL pmci_server_initialize
+!
+!-- Receive and interpolate initial data on client
+    CALL pmci_client_initialize
+!
+!-- TO_DO, maybe removed
+!-- Obs. Nesting may be unnecessary at this point.
+!
+!-- Nest boundary conditions
+    CALL pmci_server_datatrans( server_to_client )
+    CALL pmci_client_datatrans( server_to_client )
+
+    IF ( nesting_mode == 'two-way' )  THEN
+       CALL pmci_server_datatrans( client_to_server )
+       CALL pmci_client_datatrans( client_to_server )
+!
+!--    Exchange_horiz is needed for all server-domains after the anterpolation
+       CALL exchange_horiz( u, nbgp )
+       CALL exchange_horiz( v, nbgp )
+       CALL exchange_horiz( w, nbgp )
+       CALL exchange_horiz( pt, nbgp )
+       IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
+       intermediate_timestep_count = 0
+       CALL pres
+    ENDIF
+!
+!-- Correct the w top-BC in nest domains to ensure mass conservation.
+!-- Copy the interpolated/anterpolated boundary values to the _p
+!-- arrays, too, to make sure the interpolated/anterpolated boundary
+!-- values are carried over from one RK inner step to another.
+!-- These actions must not be done for the root domain.
+    IF ( nest_domain )  THEN
+       CALL pmci_ensure_nest_mass_conservation
+       CALL pmci_update_new
+    ENDIF
+#endif
 
 #if defined( __dvrp_graphics )
@@ -309,5 +362,14 @@
        IF ( simulated_time /= 0.0_wp )  THEN
           CALL timestep
-       ENDIF
+
+#if defined( PMC_ACTIVE )
+!
+!--       TO_DO: try to give more detailed and meaningful comments here
+!--       Server side must be called first
+          CALL pmci_server_synchronize
+          CALL pmci_client_synchronize
+#endif
+       ENDIF
+
 
 !
@@ -628,4 +690,46 @@
 !--       Swap the time levels in preparation for the next time step.
           CALL swap_timelevel
+
+#if defined( PMC_ACTIVE )
+!
+!--       TO_DO: try to give more meaningful comments here
+!--       Domain nesting
+!--       Note that the nesting operations are omitted intentionally on the
+!--       first two RK-substeps.
+          CALL cpu_log( log_point(60), 'nesting', 'start' )
+!
+!--       From server to client commmunication ( direction=SERVER_TO_CLIENT )
+          CALL pmci_server_datatrans( server_to_client )
+          CALL pmci_client_datatrans( server_to_client )
+
+          IF ( nesting_mode == 'two-way' )  THEN
+!
+!--          From client to server commmunication ( direction=CLIENT_TO_SERVER )
+             CALL pmci_server_datatrans( client_to_server )
+             CALL pmci_client_datatrans( client_to_server )
+!
+!--          Exchange_horiz is needed for all server-domains after the
+!--          anterpolation
+             CALL exchange_horiz( u, nbgp )
+             CALL exchange_horiz( v, nbgp )
+             CALL exchange_horiz( w, nbgp )
+             CALL exchange_horiz( pt, nbgp )
+             IF ( humidity  .OR.  passive_scalar )  THEN
+                CALL exchange_horiz( q, nbgp )
+             ENDIF
+             IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
+          ENDIF
+!
+!--       Correct the w top-BC in nest domains to ensure mass conservation.
+!--       This action must never be done for the root domain.
+          IF ( nest_domain )  THEN
+             CALL pmci_ensure_nest_mass_conservation
+!
+!--          pmc_update_new is not necessary if nesting is made at each substep.
+             CALL pmci_update_new
+          ENDIF
+
+          CALL cpu_log( log_point(60), 'nesting', 'stop' )
+#endif
 
 !
@@ -1041,5 +1145,8 @@
 !
 !--    Output elapsed simulated time in form of a progress bar on stdout
+!--    TO_DO: should be done by root domain later
+#if ! defined( PMC_ACTIVE )
        IF ( myid == 0 )  CALL output_progress_bar
+#endif
 
        CALL cpu_log( log_point_s(10), 'timesteps', 'stop' )
@@ -1048,5 +1155,8 @@
     ENDDO   ! time loop
 
+!-- TO_DO: should be done by root domain later
+#if ! defined( PMC_ACTIVE )
     IF ( myid == 0 )  CALL finish_progress_bar
+#endif
 
 #if defined( __dvrp_graphics )
